<?php
/*
+----------------------------------------------------------------+
|																 |
|	WordPress 2.6.1 Plugin: WP-ReportPost 0.1b					 |
|	Copyright (c) 2008 Rajeevan									 |
|																 |
|	File Written By:											 |
|	- Rajeevan													 |
|	- http://rjeevan.com										 |
|																 |
|	File Information:											 |
|	- Configure Report Post										 |
|	- wp-content/plugins/wp-reportpost/rp-options.php			 |
|																 |
+----------------------------------------------------------------+
*/


### If Form Is Submitted
if($_POST['Submit']) {
	// Update options After Validating
	$rp_send_email=isset($_POST['rp_send_email']) && is_numeric($_POST['rp_send_email'])?$_POST['rp_send_email']:0;
	$rp_email_address=isset($_POST['rp_email_address'])?$_POST['rp_email_address']:get_option('admin_email');
	$rp_display_text=isset($_POST['rp_display_text'])?$_POST['rp_display_text']:'[!] Report This Post';
	$rp_thanks_msg=isset($_POST['rp_thanks_msg'])?$_POST['rp_thanks_msg']:'<strong>Thanks for Reporting [post_title]</strong>';
	$report_options=isset($_POST['reportoptions'])?$_POST['reportoptions']:'Report contents';
	$report_if=(int)isset($_POST['report_if'])?$_POST['report_if']:1;
	
	// Update
	$update_query=array();
	$update_text=array();
	
	$update_query[]=update_option("rp_send_email",$rp_send_email);
	$update_query[]=update_option("rp_email_address",$rp_email_address);
	$update_query[]=update_option("rp_display_text",$rp_display_text);
	$update_query[]=update_option("rp_thanks_msg",$rp_thanks_msg);
	$update_query[]=update_option("rp_options",$report_options);
	$update_query[]=update_option("rp_if",$report_if);
	
	$update_text[]=__("Sending Email Option","wp-reportpost");
	$update_text[]=__("Sending Email Address","wp-reportpost");
	$update_text[]=__("Link Text","wp-reportpost");
	$update_text[]=__("Thank you Message","wp-reportpost");
	$update_text[]=__("Report Options","wp-reportpost");
	$update_text[]=__("Attach Option","wp-reportpost");
	
	$i = 0;
	$text = '';
	foreach($update_query as $u_query) {
		if($u_query) {
			$text .= '<font color="green">'.$update_text[$i].' '.__('Updated', 'wp-reportpost').'</font><br />';
		}
		$i++;
	}
	if(empty($text)) {
		$text = '<font color="red">'.__('No Option Updated', 'wp-reportpost').'</font>';
	}
	
	
} // End IF


### Needed Variables
$rp_send_email=intval(get_option("rp_send_email"));
$rp_email_address=get_option("rp_email_address");
$rp_display_text=get_option("rp_display_text");
$rp_thanks_msg=get_option("rp_thanks_msg");
$report_options=get_option("rp_options");
$report_if=(int)get_option("rp_if");

if(!$report_if || !is_numeric($report_if) || $report_if < 0 || $report_if > 3)
	$report_if = 1 ;
?>
<div class="wrap"> 
	<h2><?php _e('Report Post Options', 'wp-reportpost'); ?></h2> 
	
	<?php if(!empty($text)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$text.'</p></div>'; } ?>
	
	<form method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>" enctype="multipart/form-data">
	
	<?php wp_nonce_field('update-options'); ?>
	
	<table class="form-table">
		<tr>
			<th scope="row" valign="top">Version:</th>
			<td><?php echo get_option("rp_version");?></td>
		</tr>
		<tr>
		  <th scope="row" valign="top">Report:</th>
		  <td>
          	<select name="report_if">
            	<option value="1" <?php if($report_if==1) echo 'selected="Selected"';?>>Attach to All Posts</option>
                <option value="2" <?php if($report_if==2) echo 'selected="Selected"';?>>Post have Custom Fields</option>
                <option value="3" <?php if($report_if==3) echo 'selected="Selected"';?>>Manually [Theme Edit]</option>
            </select><br />
            <small><strong>Attach to All Posts : </strong>Report Form will be Attached to ALL Posts</small> <br />
            <small><strong>Post have Custom Fields :</strong> If you select this Option, Your Posts will have Custom Fields to Tick. Report Form will Only shows to Those posts have Selected this Option...</small> <br />
            <small><strong>Manually [Theme Edit] :</strong> You will have to Edit your Theme; and Include 'wprp();' PHP tag to Include Report Form (Only works with POSTS)[eg: &lt;?php echo wprp();?&gt;  #or &lt;?php wprp(true);?&gt;]</small>
          </td>
	  </tr>
		<tr>
			<th scope="row" valign="top">Link Text:</th>
			<td><input name="rp_display_text" type="text" value="<?php echo $rp_display_text; ?>" size="40" /></td>
		</tr>
		<tr>
			<th scope="row" valign="top">Thanks Message:</th>
			<td><input name="rp_thanks_msg" type="text" value="<?php echo $rp_thanks_msg; ?>" size="40" /><br />
		    [post_title] will be Replaced with Reported Post Title</td>
		</tr>
		<tr>
		  <th scope="row" valign="top">Report options:</th>
		  <td>
          <textarea name="reportoptions" cols="30" rows="3"><?php echo $report_options; ?></textarea><br />Sperated by |</td>
	  </tr>
		<tr>
		  <th scope="row" valign="top">&nbsp;</th>
		  <td>&nbsp;</td>
	  </tr>
		<tr>
			<th scope="row" valign="top">Send Email:</th>
			<td>
				<select id="rp_send_email" name="rp_send_email">
					<option value="0" <?php if($rp_send_email==0){ echo "selected=\"selected\"";}?>>No</option>
					<option value="1" <?php if($rp_send_email==1){ echo "selected=\"selected\"";}?>>Yes</option>
				</select>
			</td>
		</tr>
		<tr>
			<th scope="row" valign="top">Email:</th>
			<td><input type="text" name="rp_email_address" value="<?php echo $rp_email_address; ?>" /></td>
		</tr>
	</table>
	
	<p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
	</p>
	</form>
</div>