<?php
/*
Plugin Name: WP-ReportPost
Plugin URI: http://rjeevan.com
Description: Add Report Post to End of Contents. useful when you want user to Report Broken Links on your Posts!
Version: 1.1.1
Author: Rajeevan
Author URI: http://rjeevan.com
*/

/* Maping Filters / Action Hooks 
----------------------------------------*/
add_action('wp_head',wprp_head);	// Adding Scripts and CSS to header
add_action('init',wprp_init);
add_filter('the_content',wprp_report_choose);
add_action('admin_menu', 'wprp_post_form');
add_action('save_post', 'wprp_post_save');



/* Add Necesary Javascripts & CSS to Header
----------------------------------------*/
function wprp_init()
{
	// If Admin Pages, No need for Styles & Scripts
	if(is_admin())
		return;
		
	// Add jQuery
	wp_enqueue_script('jquery');
}
function wprp_head()
{
	// If Admin Pages, No need for Styles & Scripts
	if(is_admin())
		return;	
	
	// Add CSS
	?>
    <link href="<?php echo path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/wprp.css") ?>" rel="stylesheet" type="text/css" />
    <?php
	
	// Add  Javascripts to Do the Biddings
	?>
    <script language="javascript" type="text/javascript">
	function wprp_toggle(form_name, postID)
	{
		jQuery(form_name).slideToggle(400);
		return false;
	}
	
	function wprp_report(form)
	{
		// get POST DATA
		var post_ID=form.post.value;
		var reportas=form.report_as.value;
		var desc=form.description.value;
		
		// Hide All Other than Message
		jQuery('#wprp_report_link_'+post_ID).hide();
		jQuery('#wprpform'+post_ID).hide();
		jQuery('#wprp_message_'+post_ID).fadeIn(100);
		
		// Send Ajax
		jQuery.post("<?php echo path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/reportPost.php"); ?>", { postID: post_ID, report_as:reportas, description: desc, do_ajax_report:"true" },
		  function(data){
			// Display the Return
			jQuery('#wprp_message_'+post_ID).html(data);
		  });
		
		return false;
	}
	</script>
    <?php
}

/* Attach Custom Fields*/
function wprp_post_form()
{
	$report_if=(int)get_option("rp_if");
	if($report_if != 2)
		return;
		
	if( function_exists( 'add_meta_box' )) {
    add_meta_box( 'wprb_custom_field', __( 'Report Post Option', 'wprb_custom_field' ), 
                'wprb_custom_field', 'post', 'advanced', 'high' );
   }

}
function wprp_post_save($post_id ){
	// Verify
	if ( !wp_verify_nonce( $_POST['wprp_noncename'], plugin_basename(__FILE__) )) {
    	return $post_id;
 	}
	if ( 'post' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_post', $post_id ))
			return $post_id;
	}else{
		return $post_id;
	}

	// Get the POST
	$wprp = (int) isset($_POST['wprp_report']) ? $_POST['wprp_report'] : -1;
	
	// Update the META
	update_post_meta($post_id,'wprp', $wprp);
	
	return $post_id;
}
function wprb_custom_field()
{
	// Use nonce for verification

  echo '<input type="hidden" name="wprp_noncename" id="wprp_noncename" value="' . 
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
	
	global $post;
	
	// Last value
	$custom_field = (int)get_post_meta($post->ID, 'wprp', true);
	if(!$custom_field || empty($custom_field) || !is_numeric($custom_field) || $custom_field!=1)
		$custom_field = 0;
	?>
    <label><input type="checkbox" name="wprp_report" id="wprp_report" value="1" <?php if($custom_field==1) echo 'checked="checked"';?> /> Check this if you like to Include the "Report POST" option</label>
    <?php
}

/* Decide to Show or Not by Users Option*/
function wprp_report_choose($text)
{
	// Check for RSS 
	if(is_feed())	// Prevent from attaching to Feeds
		return $text;
		
	if(is_page())	// Prevent from Reporting Pages
		return $text;
		
	// Get the Option
	$report_if=(int)get_option("rp_if");
	if($report_if <= 0)
		$report_if = 1 ;
	
	if($report_if == 3)
		return $text;
	
	# Check for Custom Field for this POST
	if($report_if == 2)
	{
		// Get Current POST from Global
		global $post;
		
		// Get the Meta
		$custom_field = (int)get_post_meta($post->ID, 'wprp', true);
		if(!$custom_field || empty($custom_field) || !is_numeric($custom_field) || $custom_field!=1)
			return $text;
	}
	
	# Else always Attach
	return wprp_report_form($text);
}

/* Attach Reporting Form to Contents
----------------------------------------*/
function wprp($echo = false)
{
	$text = wprp_report_form('');
	if($echo)
		echo $text;
		
	return $text;
}
function wprp_report_form($text)
{
	// Check for RSS 
	if(is_feed())	// Prevent from attaching to Feeds
		return $text;
		
	if(is_page())	// Prevent from Reporting Pages
		return $text;
		
	// Get Current POST from Global
	global $post;
	
	// Get the Options
	$options=get_option('rp_options');
	$options=(empty($options)) ? array("Report") : split('\|',$options);
	
	// Create Options
	$select_options="";
	foreach($options as $opt)
		$select_options .='<option value="'.$opt.'">'.$opt.'</option>'."\n";
	
	
	// Create the FORM
	$form='
	<div class="wprp_clear"></div>
	<div class="wprp_wrapper">
	<div class="wprp_report_link" id="wprp_report_link_'.$post->ID.'">
    	<a href="#" onclick="return wprp_toggle(\'#wprpform'.$post->ID.'\',\''.$post->ID.'\');">'.get_option('rp_display_text').'</a>
    </div>
	<div id="wprp_message_'.$post->ID.'" class="wprp_message">
		<img src="'.path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/loading.gif").'" title="Processing your request, Please wait..." /> Processing your request, Please wait....
	</div>
	<div class="wprp_form" id="wprpform'.$post->ID.'">
    <form action="" method="post" enctype="text/plain" onsubmit="return wprp_report(this);">
    	<table width="100%" border="0" cellspacing="0" cellpadding="5">
		  <tr>
			<td align="right"><label>Report as: </label></td>
			<td align="left"><select name="report_as" id="report_as">
					'.$select_options.'
				</select></td>
		  </tr>
		  <tr>
			<td align="right"><label>Write in Words: <br> (Optional) </label></td>
			<td align="left"><textarea name="description" cols="40" rows="3"></textarea></td>
		  </tr>
		  <tr>
			<td align="right" colspan="2">
				<input type="hidden" value="'.$post->ID.'" name="post">
				<input name="do_report" type="submit" value="Submit Report" class="wprp_submit">
			</td>
		  </tr>
		</table>
    </form>
    </div>
	</div>
	';
	
	// Attach Form to the Contents
	
	$text .= $form;
	
	// Return Final Contents
	return $text;
}


/* Add Menu to Admin Pages
----------------------------------------*/
add_action('admin_menu', 'wprp_admin_menu');
function wprp_admin_menu()
{
	add_submenu_page(dirname(__FILE__)."/wp-options.php", 'Settings', 'Settings', 4, dirname(__FILE__)."/wp-options.php");
	add_menu_page('Report Posts', 'Report Posts', 4, dirname(__FILE__)."/wp-options.php");
	add_submenu_page(dirname(__FILE__)."/wp-options.php", 'New Reports', 'New Reports', 4, dirname(__FILE__)."/wp-reports.php");
	add_submenu_page(dirname(__FILE__)."/wp-options.php", 'Archived Reports', 'Archived Reports', 4, dirname(__FILE__)."/wp-archive.php");
}

/* Install & Uninstall
----------------------------------------*/
register_activation_hook(__FILE__,"wprp_install");
// register_deactivation_hook(__FILE__,"wprp_uninstall");

function wprp_install()
{
	global $wpdb;
	
	// Check and Update Existing Database
	$table_name=$wpdb->prefix.'reportpost';
	
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		// add Database
		$sql = "CREATE TABLE " . $table_name . " (
	  	post_id bigint(20) NOT NULL,
	  	post_title TEXT NOT NULL,
	  	user_ip VARCHAR( 40 ) NOT NULL,
	  	description TEXT NULL,
	  	stamp VARCHAR( 15 ) NOT NULL,
	  	status INT(1) NOT NULL DEFAULT '0',
	  	PRIMARY KEY (post_id)
		);";
		
		// Execute SQL
		$wpdb->query( $wpdb->prepare($sql));
	}else{

		// update if New Version
		
		if(get_option('rp_version') != "1.1.0")
		{
			$sql="ALTER TABLE ".$table_name." ADD status INT(1) NOT NULL DEFAULT 0, ADD description TEXT NOT NULL;";
			
			$wpdb->query( $wpdb->prepare($sql));
		}
	}
	
	// ADD New Versions
	if(!get_option('rp_version') || get_option('rp_version')!="1.1.1")
	{
		if( get_option('rp_version')!="1.1.1")
			update_option("rp_version","1.1.1");

		add_option("rp_version","1.1.1",'','no');
		add_option("rp_send_email",0,'','no');
		add_option("rp_email_address",get_option("admin_email"),'','no');
		add_option("rp_display_text","[!] Report This Post");
		add_option("rp_thanks_msg","<strong>Thanks for Reporting [post_title]</strong>",'','no');
		add_option("rp_options","Broken Links|Invalid / Wrong Links|Missing / Invalid Password|Other",'','yes');
	}
}

?>
